<template>
  <div v-show="entry.id" class="EditDialog__Backdrop" @click="close"></div>
  <dialog class="EditDialog" open>
    <InputField
      v-model="entry.content"
      :label="t('entry.content')"
      class="EntryBlock__Content"
    />

    <RangePicker v-model="entry" :locale="locale" v-if="entry.stop" />

    <DateTimePicker
      v-model="entry.start"
      :label="t('entry.date.start')"
      :locale="locale"
      v-else
    />

    <div class="EditDialog__Controls">
      <Button
        :icon="Icons.remove"
        :title="t('entry.remove')"
        class="EditDialog__Remove Color--danger Button--outlined"
        @click="remove"
      />
      <Button
        :icon="Icons.restore"
        :title="t('component.restore')"
        class="EditDialog__Restore Button--outlined"
        @click="restore"
        :disabled="pristine"
      />
      <Button
        :icon="Icons.check"
        :label="t('entry.save')"
        class="Color--primary Button--outlined"
        @click="save"
      />
    </div>
  </dialog>
</template>

<script lang="ts">
import { defineComponent, inject, PropType, reactive, toRefs } from 'vue'
import { Entry } from '@/types'
import { Button, DateTimePicker, RangePicker } from '@/components'
import { Icons } from '@/Icons'
import * as Helpers from '@/helpers'
import { Now, locale } from '@/states'
import InputField from '@/components/controls/InputField.vue'
import { cloneDeep } from 'lodash'

export default defineComponent({
  name: 'EntryDialog',
  emits: ['update:modelValue', 'close', 'remove'],
  components: { RangePicker, DateTimePicker, InputField, Button },
  props: {
    modelValue: Object as PropType<Entry> | null,
  },

  setup(props) {
    const reactiveData: { entry: Entry } = reactive({
      entry: cloneDeep(props.modelValue),
    })

    return {
      ...toRefs(reactiveData),
      humanizeDate: Helpers.Entry.humanizeDate,
      Now,
      locale,
      Icons,
      t: inject('t', (str: unknown) => str),
    }
  },

  computed: {
    pristine(): boolean {
      return JSON.stringify(this.entry) === JSON.stringify(this.modelValue)
    },
  },

  methods: {
    stop() {
      Helpers.Entry.stop(this.entry)
    },

    /**
     * Close dialog
     */
    close() {
      this.$emit('close')
    },

    /**
     * Close dialog
     */
    save() {
      this.$emit('update:modelValue', this.entry)
      this.close()
    },

    /**
     * Remove this entry
     */
    remove() {
      this.$emit('remove', this.entry.id)
    },

    restore() {
      this.entry = cloneDeep(this.modelValue)
    },
  },
})
</script>

<style lang="scss">
@use '../../style/variables' as v;

.EditDialog {
  @keyframes appear {
    from {
      opacity: 0;
      transform: translateX(-3rem);
    }

    to {
      opacity: 1;
      transform: translateX(0);
    }
  }

  border: 1px solid var(--border-color);
  background-color: var(--background-color);
  color: var(--text-color);

  &__Backdrop {
    position: fixed;
    top: 0;
    left: 0;
    width: 100vw;
    height: 100vh;
    background-color: var(--view-background-color);
    opacity: 50%;
  }

  &[open] {
    animation: appear 0.15s cubic-bezier(0, 1.8, 1, 1.8);
  }

  &__Controls {
    display: inline-flex;
    align-items: center;
    justify-content: flex-start;
    width: 100%;
    margin-top: v.$spacing;

    > :not(:first-child) {
      margin-left: v.$spacing;
    }

    &::before {
      content: '';
      flex: 1 1;
      order: -1;
    }
  }

  &__Remove {
    order: -2;
  }
}
</style>
